class Event {

	XmlFileButton()
	{
		Gui, +OwnDialogs
		FileSelectFile, File,,
			, % Txt.Get("XmlFileSelectFilePromt")
			, XML-Dateien (*.xml)
		if (XmlStylesheets := Xml.InputFile := File) {
			Gui.XmlFileEdit := File
			SplitPath, File,, WorkingDir
			SetWorkingDir, % WorkingDir
			Gui.AddXsltButton := 1
			Gui.RemoveXsltButton := 0
			Gui.XsltUpButton := 0
			Gui.XsltDownButton := 0
			Config.XsltList := []
			Config.XsltSelectedRow := 0
			if (XmlStylesheets = "XmlStylesheets") {
				MsgBox, 36, % Txt.Get("XmlStylesheetsMsgBoxTitle"), % Txt.Get("XmlStylesheetsMsgBoxText")
				IfMsgBox, Yes
				{
					for media, items in Xml.XmlStylesheets {
						for index, href in items {
							Config.XsltListItem := href
						}
						break
					}
				}
			} else if (XmlStylesheets = "MediaChoice") {
				MediaChoiceDialog.Box()
			}
			Gui.ParameterListView := {}
			Gui.AddParameterButton := 0
			Gui.EditParameterButton := 0
			Gui.RemoveParameterButton := 0
			Gui.XsltListView := Config.XsltList
			Gui.TransformationButton := (Config.XsltList.Length()) ? 1 : 0
		}
	}
	
	AddXsltButton()
	{
		Gui, +OwnDialogs
		FileSelectFile, File,,
			, % Txt.Get("XsltFileSelectFilePromt")
			, XSL-Dateien (*.xsl)
		if (File) {
			Gui.TransformationButton := 1
			SelectedRow := Config.XsltSelectedRow
			Config.XsltListItem["Add", SelectedRow] := File
			Gui.XsltListView := Config.XsltList
			if SelectedRow {
				Config.XsltSelectedRow += 1
				SelectedRow += 1
			}
			Gui.XsltListView["Select"] := SelectedRow
		}
	}
	
	RemoveXsltButton()
	{
		SelectedRow := Config.XsltSelectedRow
		Config.XsltListItem["Remove"] := SelectedRow
		Gui.XsltListView := Config.XsltList
		Gui.RemoveXsltButton := 0
		Gui.XsltUpButton := 0
		Gui.XsltDownButton := 0
		Gui.ParameterListView := []
		Gui.AddParameterButton := 0
		if not Config.XsltList.Length() {
			Gui.TransformationButton := 0
		}
	}
	
	XsltUpButton()
	{
		SelectedRow := Config.XsltSelectedRow
		Config.XsltListItem["Up"] := SelectedRow
		Gui.XsltListView := Config.XsltList
		SelectedRow -= 1
		Gui.XsltListView["Select"] := SelectedRow
	}
	
	XsltDownButton()
	{
		SelectedRow := Config.XsltSelectedRow
		Config.XsltListItem["Down"] := SelectedRow
		Gui.XsltListView := Config.XsltList
		SelectedRow += 1
		Gui.XsltListView["Select"] := SelectedRow
	}
	
	AddParameterButton()
	{
		ParameterDialog.Box("Add")
	}
	
	EditParameterButton()
	{
		for key, value in Config.ParameterSelection {
			SelectedParameterKey := key
			SelectedParameterValue := value
			break
		}
		ParameterDialog.Box("Edit", SelectedParameterKey, SelectedParameterValue)
	}
	
	RemoveParameterButton()
	{
		XsltSelectedRow := Config.XsltSelectedRow
		for key in Config.ParameterSelection {
			ParameterKey := key
			break
		}
		Config.ParameterListItem[XsltSelectedRow, ParameterKey, "Remove"] := 1
		Gui.ParameterListView := Config.ParameterList[XsltSelectedRow]
		Gui.EditParameterButton := 0
		Gui.RemoveParameterButton := 0
	}
	
	TransformationButton()
	{
		if Xml.Transform() {
			InputFileNameNoExt := Xml.InputFileNameNoExt
			OutputMethod := Xml.OutputMethod
			FileExt := (OutputMethod = "text") ? "txt" : OutputMethod
			FileSelectFile, ResultFilePath, S16, % A_WorkingDir "\" InputFileNameNoExt ".out." FileExt
				, % Txt.Get("ResultFileSelectFilePromt")
			if ResultFilePath {
				Xml.WriteXmlResultFile(ResultFilePath)
			}
		}
		
	}
}

XsltListViewEvent()
{
	global XsltListView
	Critical
	if (A_GuiEvent = "I" and InStr(ErrorLevel, "S", true)) {
		Config.XsltSelectedRow := A_EventInfo
		Gui.RemoveXsltButton := 1
		Gui.XsltUpButton := (A_EventInfo > 1) ? 1 : 0
		if (A_DefaultListView != "XsltListView")	{
			Gui, ListView, XsltListView
		}
		XsltListLength := LV_GetCount()
		Gui.XsltDownButton := (A_EventInfo < XsltListLength) ? 1 : 0
		Gui.ParameterListView := Config.ParameterList[A_EventInfo]
		Gui.AddParameterButton := 1
		Gui.EditParameterButton := 0
		Gui.RemoveParameterButton := 0
	} else if (A_GuiEvent = "I" and InStr(ErrorLevel, "s", true)) {
		if (A_DefaultListView != "XsltListView")	{
			Gui, ListView, XsltListView
		}
		if not LV_GetNext(0) {
			Config.XsltSelectedRow := 0
			Gui.RemoveXsltButton := 0
			Gui.XsltUpButton := 0
			Gui.XsltDownButton := 0
			Gui.ParameterListView := []
			Gui.AddParameterButton := 0
			Gui.EditParameterButton := 0
			Gui.RemoveParameterButton := 0
		}
	}
}

ParameterListViewEvent()
{
	global ParameterListView
	Critical
	if (A_GuiEvent = "I" and InStr(ErrorLevel, "S", true)) {
		Gui.EditParameterButton := 1
		Gui.RemoveParameterButton := 1
		if (A_DefaultListView != "ParameterListView")	{
			Gui, ListView, ParameterListView
		}
		LV_GetText(ParameterName, A_EventInfo)
		LV_GetText(ParameterValue, A_EventInfo, 2)
		Config.ParameterSelection := {(ParameterName): ParameterValue}
	} else if (A_GuiEvent = "I" and InStr(ErrorLevel, "s", true)) {
		if (A_DefaultListView != "ParameterListView")	{
			Gui, ListView, ParameterListView
		}
		if not LV_GetNext(0) {
			Config.ParameterSelection := {}
			Gui.EditParameterButton := 0
			Gui.RemoveParameterButton := 0
		}
	}
}

GuiClose:
WinHwnd := WinExist("Ahk_PID " DllCall("GetCurrentProcessId"))
if DialogHwnd.HasKey(WinHwnd) {
	ClassName := DialogHwnd[WinHwnd]
	%ClassName%.CloseGui()
} else {
	ExitApp
}
return